CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

GetWeight Method (ActiveX)

2023-1-4 06:27| 发布者: admin| 查看: 704| 评论: 0|来自: AutoCAD

摘要: 获取给定索引处控制点的权重。

获取给定索引处控制点的权重。

支持的平台:仅窗口

签名

工 务 局:

RetVal = object.GetWeight(Index)
对象

类型:样条

此方法适用的对象。

指数

访问:仅输入

类型:整数

构成样条曲线的点数组中的索引位置。以 0 开头的正整数。

返回值(RetVal)

类型:

指定控制点的权重。

言论

控制点通过向样条曲线的一部分添加权重来微调样条定义。

例子

工 务 局:

Sub Example_GetWeight()
    ' This example creates a spline object in model space.
    ' It then finds the weight of the first control point
    ' and changes that value.

    ' Create the spline
    Dim splineObj As AcadSpline
    Dim startTan(0 To 2) As Double
    Dim endTan(0 To 2) As Double
    Dim fitPoints(0 To 8) As Double
    
    startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0
    endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0
    fitPoints(0) = 1: fitPoints(1) = 1: fitPoints(2) = 0
    fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0
    fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0
    Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan)
    ZoomAll
    
    ' Display the coordinates of the first fit point
    Dim weight As Double
    weight = splineObj.GetWeight(0)
    MsgBox "The weight of control point 1 is " & weight, , "GetWeight Example"
    
    ' Change the weight of the first control point
    weight = 5
    splineObj.SetWeight 0, weight
    splineObj.Update
    MsgBox "The weight of control point 1 is now " & weight, , "GetWeight Example"
    
End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_GetWeight()
    ;; This example creates a spline object in model space.
    ;; It then finds the weight of the first control point
    ;; and changes that value.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))
  
    ;; Create the spline
    (setq startTan (vlax-3d-point 0.5 0.5 0)
          endTan (vlax-3d-point 0.5 0.5 0)
          fitPoints (vlax-make-safearray vlax-vbDouble '(0 . 8)))
    (vlax-safearray-fill fitPoints '(1 1 0
                                     5 5 0
                                     10 0 0
                                    )
    )

    (setq modelSpace (vla-get-ModelSpace doc))
    (setq splineObj (vla-AddSpline modelSpace fitPoints startTan endTan))
    (vla-ZoomAll acadObj)
    
    ;; Display the coordinates of the first fit point
    (setq weight (vla-GetWeight splineObj 0))
    (alert (strcat "The weight of control point 1 is " (rtos weight 2)))
    
    ;; Change the weight of the first control point
    (setq weight 5)
    (vla-SetWeight splineObj 0 weight)
    (vla-Update splineObj)
    (alert (strcat "The weight of control point 1 is now " (rtos weight 2)))
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-19 14:27

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部